<!DOCTYPE html>
<html lang="en">

<head>
  <title>Danh Sách Đơn Hàng</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <div class="container-fluid">
    <!-- Vùng header -->
    <h3 class="text-center mt-3 font-weight-bolder">DANH SÁCH ĐƠN HÀNG</h3>
    <!-- Vùng Table -->
    <table id="order-table" class="table table-bordered table-striped table-hover">
      <thead style="background-color: cornflowerblue; color: azure;">
        <tr>
          <th>STT</th>
          <th>Mã đơn hàng</th>
          <th>Họ và tên</th>
          <th>Payment Method</th>
          <th>Số lựợng sản phẩm</th>
          <th>Tổng tiền</th>
          <th>Ngày đặt hàng</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>

  <!-- Vùng Modal: hãy tạo các modal ở bên dưới đây -->
  <!-- Modal sửa -->
  <div>
    <div class="modal fade" id="modal-update-order">
      <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Chi tiết đơn hàng</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <div class="row">
              <div class="form-group col-6 d-flex flex-wrap">
                <label for="inp-firstname-update-modal" class="col-form-label col-4">Họ và đệm</label>
                <input type="text" class="form-control col-8" placeholder="họ và đệm" id="inp-firstname-update-modal">
              </div>
              <div class="form-group col-6 d-flex flex-wrap">
                <label for="inp-lastname-update-modal" class="col-form-label col-4">Tên</label>
                <input type="text" class="form-control col-8" placeholder="tên" id="inp-lastname-update-modal">
              </div>
            </div>
            <div class="row">
              <div class="form-group col-6 d-flex flex-wrap">
                <label for="inp-email-update-modal" class="col-form-label col-4">Email</label>
                <input type="email" class="form-control col-8" placeholder="email" id="inp-email-update-modal">
              </div>
              <div class="form-group col-6 d-flex flex-wrap">
                <label for="inp-phone-update-modal" class="col-form-label col-4">Phone</label>
                <input type="text" class="form-control col-8" placeholder="số điện thoại" id="inp-phone-update-modal">
              </div>
            </div>
            <div class="row">
              <div class="form-group col-12 d-flex flex-wrap">
                <label for="inp-address-update-modal" class="col-form-label col-2">Address</label>
                <input type="text" class="form-control col-10" placeholder="địa chỉ" id="inp-address-update-modal">
              </div>
            </div>
            <div class="row">
              <div class="form-group col-6 d-flex flex-wrap">
                <label for="select-payment-method-update-modal" class="col-form-label col-4">Payment Method</label>
                <select name="select-payment-method-update-modal" id="select-payment-method-update-modal"
                  class="form-control col-8">
                  <option value="CreditCard">Credit Card</option>
                  <option value="Paypal">Paypal</option>
                  <option value="BankTransfer">Bank Transfer</option>
                </select>
              </div>
              <div class="form-group col-6 d-flex flex-wrap">
                <label for="inp-voucher-update-modal" class="col-form-label col-4">Mã giảm giá</label>
                <input type="text" class="form-control col-8" placeholder="mã giảm giá" id="inp-voucher-update-modal">
                <p class="w-100 text-center font-italic" style="display: none;" id="p-voucher-discount"></p>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" data-dismiss="modal">Hủy</button>
            <button class="btn btn-success" id="btn-order-update-modal">Cập nhật</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- Modal xóa -->
  <div>
    <div class="modal fade" id="modal-delete-order">
      <div class="modal-dialog modal-sm">
        <div class="modal-content">
          <div class="modal-header">
            <h6 class="modal-title" id="h6-modal-title">Confirm xóa order</h6>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <p>Bạn có chắc chắn muốn xóa order này không?</p>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" data-dismiss="modal">Hủy</button>
            <button class="btn btn-danger" id="btn-order-delete-modal">Xóa</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  $(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://food-ordering-fvo9.onrender.com/api";
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gORDER_COLS = ["stt", "orderCode", "id", "methodPayment", "foods", "foods", "createdAt", "id"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gPRODUCT_STT_COL = 0;
    const gPRODUCT_MA_DON_HANG_COL = 1;
    const gPRODUCT_HO_VA_TEN_COL = 2;
    const gPRODUCT_PAYMENT_METHOD_COL = 3;
    const gPRODUCT_SO_LUONG_SAN_PHAM_COL = 4;
    const gPRODUCT_TONG_TIEN_COL = 5;
    const gPRODUCT_NGAY_DAT_HANG_COL = 6;
    const gPRODUCT_ACTION_COL = 7;
    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Biến toàn cục để lưu
    var gOrderArray = [];
    var gOrder = {};
    var gVoucher = {};
    var gDeleteOrderId = "";
    // Khai báo DataTable & mapping collumns
    var gOrderTable = $("#order-table").DataTable({
      columns: [
        { data: gORDER_COLS[gPRODUCT_STT_COL] },
        { data: gORDER_COLS[gPRODUCT_MA_DON_HANG_COL] },
        { data: gORDER_COLS[gPRODUCT_HO_VA_TEN_COL] },
        { data: gORDER_COLS[gPRODUCT_PAYMENT_METHOD_COL] },
        { data: gORDER_COLS[gPRODUCT_SO_LUONG_SAN_PHAM_COL] },
        { data: gORDER_COLS[gPRODUCT_TONG_TIEN_COL] },
        { data: gORDER_COLS[gPRODUCT_NGAY_DAT_HANG_COL] },
        { data: gORDER_COLS[gPRODUCT_ACTION_COL] },
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gPRODUCT_STT_COL,
          render: function () {
            return gSTT++;
          }
        },
        { // định nghĩa lại cột họ và tên
          targets: gPRODUCT_HO_VA_TEN_COL,
          render: function (paramData) {
            for (var bI = 0; bI < gOrderArray.length; bI++) {
              if (gOrderArray[bI].id == paramData) {
                return gOrderArray[bI].firstName + " " + gOrderArray[bI].lastName;
              }
            }
          }
        },
        { // định nghĩa lại cột số lượng sản phẩm
          targets: gPRODUCT_SO_LUONG_SAN_PHAM_COL,
          render: function (paramData) {
            return paramData.length;
          }
        },
        { // định nghĩa lại cột tổng tiền
          targets: gPRODUCT_TONG_TIEN_COL,
          render: function (paramData) {
            var vPriceSum = 0;
            for (var bI = 0; bI < paramData.length; bI++) {
              vPriceSum += paramData[bI].price;
            }
            return "$ " + vPriceSum;
          }
        },
        { // định nghĩa lại cột ngày đặt hàng
          targets: gPRODUCT_NGAY_DAT_HANG_COL,
          render: function (paramData) {
            var vDate = paramData.slice(0, 10);
            var vFormatDate = vDate.split("-").reverse().join("-"); //chuyển format từ yyyy-mm-dd sang dd-mm-yyyy
            return vFormatDate;
          }
        },
        { // định nghĩa lại cột action
          targets: gPRODUCT_ACTION_COL,
          render: function (paramData) {
            return `
                <img class="edit-order" data-id=${paramData} src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                <img class="delete-order" data-id=${paramData} src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
          }
        }
      ]
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // thực hiện tải trang
    onPageLoading();
    $("#order-table").on("click", ".edit-order", function () {
      onBtnEditOrderClick(this);
    });
    $("#order-table").on("click", ".delete-order", function () {
      onBtnDeleteOrderClick(this);
    });    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      //Read / Load product to DataTable
      getAllOrders();
    }
    function onBtnEditOrderClick(paramBtnEdit) {
      var vOrderId = $(paramBtnEdit).data("id");
      console.log("Update OrderID: ", vOrderId);
    }
    function onBtnDeleteOrderClick(paramBtnDelete){
        var vOrderId = $(paramBtnDelete).data("id");
        console.log("Delete OrderId: ", vOrderId);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách order
    function getAllOrders() {
      $.ajax({
        url: gBASE_URL + "/orders",
        type: "GET",
        success: function (paramOrderArray) {
          gOrderArray = paramOrderArray;
          loadDataToOrderTable(gOrderArray);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load Order array to DataTable */
    function loadDataToOrderTable(paramOrderArray) {
      gSTT = 1;
      gOrderTable.clear();
      gOrderTable.rows.add(paramOrderArray);
      gOrderTable.draw();
    }
    // hàm gọi api để lấy order by id
    function getOrderById(paramOrderId) {
      $.ajax({
        url: gBASE_URL + "/orders/" + paramOrderId,
        type: "GET",
        success: function (paramOrder) {
          gOrder = paramOrder;
          loadOrderToUpdateModal(gOrder);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
  });

</script>

</html>